#ifndef _HANIMARs_MENUWIN_H_
#define _HANIMARs_MENUWIN_H_

#include "mytypes.h"

typedef struct {
	unsigned char *title;
	void *user;
} MENUDEF;

typedef struct {
	short x, y;
	short clutX, clutY;
	short waitCount;
	short reserved;
} MENUPOINTER;

typedef struct {
	short x;
	short y;
	short w;
	short h;

	short numItem;
	short base;
	short pos;
	MENUDEF *items;

	/* \@̏ڍ */
	short charW;	/* `͈͂ɕ\ł郁j[ */
	short charH;	/* `͈͂ɕ\ł郁j[ */
	/* PF */
	unsigned long bg;			/* Ĩj[F */
	unsigned long fg;			/* Ĩj[F */
	unsigned long bg_active;	/* Iꂽj[F */
	unsigned long fg_active;	/* Iꂽj[F */
	unsigned long flags;		/* bit0: ACRtH */
#define MWIN_HASICON(pWin)	((pWin)->flags & 1)

	int numIcon;
	int curIcon;
	int waitCount;
	MENUPOINTER *icons;
} MENUWIN;

#define MW_CHAR_HEIGHT	16
#define MW_CHAR_WIDTH	8

#ifdef __cplusplus
extern "C" {
#endif

/* ŏɌĂт܂B */
void MenuWinInit(MENUWIN *pWin, short x, short y, short w, short h, MENUDEF *menus);
/* ĕ`悵܂B*/
void MenuWinRedraw(MENUWIN *pWin, short baseX, short baseY);
/* \ n Ԗڂ̃ACe` */
void MenuWinDrawItem(MENUWIN *pWin, int n, short baseX, short baseY);
int MenuWinMoveCursor(MENUWIN *pWin, int bector, short baseX, short baseY);

#define MenuWinMoveCursorByPage(pWin, bector, baseX, baseY) \
	MenuWinMoveCursor(pWin, bector * (pWin)->charH, baseX, baseY)

/* J[\̃ACRAj[VB VSync ƂɌĂ */
void MenuWinUpdatePointer(MENUWIN *pWin, short baseX, short baseY);

/* j[̘̈g */
void MenuDecorate_simple(MENUWIN *pWin, short width, RGB24 fg, RGB24 bg,
	short baseX, short baseY);

#ifdef __cplusplus
}
#endif


#endif /* _HANIMARs_MENUWIN_H_ */

